/*---------------------------------------------------------------
ArrayDelete function by Raptorsaurus
v. 1.0, 3/19/10

Deletes an element from a specified position of an array. Elements in the array that are after
the deletion point will be shifted one index toward the front of the array. If the array has less elements
than the deletion point, the array will not be affected.

The required info passed to this function is:
- The array
- The numerical index of the element to delete (0 for the first element, 1 for second element, 2 for third element, etc).

Example :

_existingArray = ["a", "b", ["this", "sub", "array"], 1, 2, 3]
_newarray = [_existingArray, 2] call ArrayDelete

_newarray will be : ["a", "b", 1, 2, 3]

Initialize this function by putting this in your init.sqs:
ArrayDelete = preprocessFile "ArrayDelete.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_array","_dnum","_front","_back","_index"];

_array = _this select 0;
_dnum = _this select 1;

// delete the element

_front = [];
_back = [];
_index = [];
{if (count _front < _dnum) then {_front = _front + [_x]}; if (count _front <= _dnum) then {_index = _index + [_x]}; if (count _index > _dnum + 1) then {_back = _back + [_x]}} forEach _array;
_front + _back