/*---------------------------------------------------------------
ArrayInsert function by Raptorsaurus
v. 1.0, 3/19/10

Inserts an element into a specified position of an array without deleteing exitsing elements of
that array. Elements in the array that are after the insertion point will be pushed toward the end
of the array. If the array has less elements than the insertion point, the inserted element will be
added to the end of the array.

The required info passed to this function is:
- The array
- The element to insert
- The numerical insertion point (0 for the front, 1 for second element, 2 for third element, etc.]

Example :

_existingArray = [0,1,2,3,4,5,6]
_newElement = "newElement"

_newarray = [_existingArray, _newElement, 3] call ArrayInsert

_newarray will be : [0,1,2,"newElement",3,4,5,6]

Initialize this function by putting this in your init.sqs:
ArrayInsert = preprocessFile "ArrayInsert.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_array","_enum","_new","_front","_back"];

_array = _this select 0;
_new = _this select 1;
_enum = _this select 2;

// insert the element

_front = [];
_back = [];
{if (count _front < _enum) then {_front = _front + [_x]} else {_back = _back + [_x]}} forEach _array;
_front + [_new] + _back