/*---------------------------------------------------------------
DeltaDir function by Raptorsaurus

This function returns the angle offset of a direction from a reference direction.

Pass info to the function in the following format:

_Angoff = [_refdir, _dir] call DeltaDir

The value of _Angoff is in the range 0 to 180 or 0 to -180 degrees.
A negative offset value indicates that the secondary direction (_dir) is to the left
or counter-clockwise from the reference direction (_refdir).

Initialize this function by putting this in your init.sqs:
DeltaDir = preprocessFile "DeltaDir.sqf"
---------------------------------------------------------------*/

private ["_ang1","_ang2","_degoff"];

_ang1 = _this select 0;
_ang2 = _this select 1;

// make sure values are in standard compass range (0 - 360)

if (_ang1 < 0) then {_ang1 = _ang1 + 360};
if (_ang1 >= 360) then {_ang1 = _ang1 - 360};
if (_ang2 < 0) then {_ang2 = _ang2 + 360};
if (_ang2 >= 360) then {_ang2 = _ang2 - 360};

// Find Direction Offset

if ((_ang1 - _ang2) > 180) then {_ang2 = _ang2 + 360};
if ((_ang2 - _ang1) > 180) then {_ang1 = _ang1 + 360};
_degoff = (_ang2 - _ang1);

_degoff