/*---------------------------------------------------------------
DirMktoMk function by Raptorsaurus

Returns the direction (compass heading) from one marker to another.  The first
marker is the reference point for the heading.

Pass the maker names to the function:

_dir = [_mrk1,_mrk2] call DirMktoMk

or

_dir = ["marker1","marker2"] call DirMktoMk

Initialize this function by putting this in your init.sqs:
DirMktoMk = preprocessFile "DirMktoMk.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_posmk1","_posmk2","_dir","_DeltaX","_DeltaY"];

//get positions

_posmrk1 = getMarkerPos (_this select 0);
_posmrk2 = getMarkerPos (_this select 1);

// calculate direction
_DeltaX = (_posmrk2 select 0) - (_posmrk1 select 0);
_DeltaY = (_posmrk2 select 1) - (_posmrk1 select 1);
if (_DeltaY == 0) then {_DeltaY = .0000001};
_dir = _DeltaX atan2 _DeltaY;

// show correct compass heading
if (_dir < 0) then { _dir = _dir + 360 };

// return value

_dir
