/*---------------------------------------------------------------
DirOfMove function by Raptorsaurus

This function returns the movement direction of an object (its movement direction
is not necessarily its getDir value - it may be going in reverse or moving sideways).
Aircraft for instance, have some "side slip" as they turn.

Pass info to the function in the following format:

_MoveDir = [_obj] call DirOfMove

Initialize this function by putting this in your init.sqs:
DirOfMove = preprocessFile "DirOfMove.sqf"
---------------------------------------------------------------*/
private ["_obj","_Vel","_Hvel","_Xvel","_Yvel","_Dir"];

_obj = _this select 0;

_vel = Velocity _obj;

_Xvel = _vel select 0;
_Yvel = _vel select 1;

// find object speed and movement direction from velocity vectors
// (this is more reliable than using "getDir" and "Speed" commands)

_Hvel = sqrt(_Xvel^2 + _Yvel^2);

// find compass direction of object (movement direction is not necessarily the "getDir" value)

if (_Hvel != 0) then {_Dir = _Xvel atan2 _Yvel} else {_Dir = getDir _obj};
if (_Dir < 0) then { _Dir = _Dir + 360 };

_Dir