/*---------------------------------------------------------------
DirOff function by Raptorsaurus

This function returns the degree off-course an object is from
facing a second object.

Pass info to the function in the following format:

_Angoff = [_refobj,_tarobj] call DirOff

The value of _Angoff is in the range 0 to 180 or 0 to -180 degrees.
A negative off-course value indicates that the course correction
requires turning to the right and a positive number indicates that
a turn to the left is needed to intercept the target.

Initialize this function by putting this in your init.sqs:
DirOff = preprocessFile "DirOff.sqf"
---------------------------------------------------------------*/

private ["_refobj","_tarobj","_objhead","_tarbear","_ang1","_ang2","_degoff"];

_refobj = _this select 0;
_tarobj = _this select 1;

_objhead = getDir _refobj;

// find bearing to _tarobj

if ( ((getpos _tarobj select 0) - (getpos _refobj select 0) != 0) || ((getpos _tarobj select 1) - (getpos _refobj select 1) != 0) )
then {_tarbear = ((getpos _tarobj select 0) - (getpos _refobj select 0)) atan2 ((getpos _tarobj select 1) - (getpos _refobj select 1))}
else {_tarbear = 180};

// make bearings true compass heading

if (_tarbear < 0) then {_tarbear = _tarbear + 360};

// Find Direction Offset

_ang1 = _objhead;
_ang2 = _tarbear;
if ((_ang1 - _ang2) > 180) then {_ang2 = _ang2 + 360};
if ((_ang2 - _ang1) > 180) then {_ang1 = _ang1 + 360};
_degoff = (_ang2 - _ang1);

_degoff