/*---------------------------------------------------------------
DirOffAng function by Raptorsaurus

This function returns the degree off-course an object is from
a desired directional heading.

Pass info to the function in the following format:

_Angoff = [_refobj,_angle] call DirOff

The value of _Angoff is in the range 0 to 180 or 0 to -180 degrees.
A negative off-course value indicates that the course correction
requires turning to the left and a positive number indicates that
a turn to the right is needed to head in the desired direction.

Initialize this function by putting this in your init.sqs:
DirOffAng = preprocessFile "DirOffAng.sqf"
---------------------------------------------------------------*/

private ["_refobj","_angle","_objhead","_ang1","_ang2","_degoff"];

_refobj = _this select 0;
_angle = _this select 1;

_objhead = getDir _refobj;

// make sure angle is true compass heading

if (_angle < 0) then {_angle = _angle + 360};

// Find Direction Offset

_ang1 = _objhead;
_ang2 = _angle;
if ((_ang1 - _ang2) > 180) then {_ang2 = _ang2 + 360};
if ((_ang2 - _ang1) > 180) then {_ang1 = _ang1 + 360};
_degoff = (_ang2 - _ang1);

_degoff