/*---------------------------------------------------------------
DirToMark function by Raptorsaurus

Returns the direction (compass heading) to a marker from an object.  The object
is the reference position.

Pass the object and marker name to the function:

_dir = [_obj,_mrk] call DirToMark

or

_dir = [_obj,"markername"] call DirToMark

Initialize this function by putting this in your init.sqs:
DirToMark = preprocessFile "DirToMark.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_posobj","_posmrk","_dir"];

//get positions

_posobj = getPos (_this select 0);
_posmrk = getMarkerPos (_this select 1);

// calculate direction
_dir = ((_posmrk select 0) - (_posobj select 0)) atan2 ((_posmrk select 1) - (_posobj select 1));

// show correct compass heading
if (_dir < 0) then { _dir = _dir + 360 };

// return value

_dir