/*---------------------------------------------------------------
DisSort function by Raptorsaurus
v. 1.1, 3/13/10 (function created _ref game logic is now deleted before function completes)

Sorts an array of objects according to their distance from a given position or object.

The required info passed to this function is:

- The base position or object (if it is an object it must be in array brackets, eg. [player]
- Array of objects to sort according to distance from the base position
- (Optional) Sort direction indicator. A positive value to sort from nearest to furthest
  from the base position and a negative value to sort from furthest to closest from the
  base position (if left off the default sorting is from closest to furthest).

Example 1:

_objarray = [getPos player, [obj1, obj2, obj3], -1] call DisSort

The 3 objects will be put in order starting with the furthest from the player and finishing with the one closest to the player.

Example 2:

_objarray = [[player], [obj1, obj2, obj3]] call DisSort

The 3 objects will be put in order starting with the closest to the player and finishing with the one furthest from the player.

Initialize this function by putting this in your init.sqs:
DisSort = preprocessFile "DisSort.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_pos","_ref","_array","_sd","_dis","_farray","_cnt","_cnt2","_elem","_erec","_input"];

_input = _this select 0;
_array = _this select 1;
_sd = 1;
if (count _this > 2) then {_sd = _this select 2};
if (count _input == 1) then {_pos = getPos (_input select 0)} else {_pos = _input};

_ref = "logic" createVehicle [0,0,0];
_ref setPos _pos;

// sort _farray from greatest distance to least distance

_cnt = 0;
_cnt2 = 0;
_farray = [];

While {_cnt2 < count _array}
Do
	{
	_dis = 0;
	_cnt = 0;
	_erec = 0;
	While {_cnt < count _array}
	Do
		{
		_elem = _array select _cnt;
		if (_elem distance _ref > _dis)
		then 
			{
			_farray set [_cnt2 , _elem];
			_dis = (_elem distance _ref);
			_erec = _cnt;
			};
		_cnt = _cnt + 1;
		};
	_array set [_erec, _ref];
	_cnt2 = count _farray;
	};

_array = _farray;
deleteVehicle _ref;

// flip the array around if least to greatest distance sorting is desired

If (_sd > 0)
then
	{
	_cnt = count _farray - 1;
	_array = [];
	While {_cnt >= 0}
	Do
		{
		_array  = _array + [_farray select _cnt];
		_cnt = _cnt - 1;
		};
	};
_array