/*---------------------------------------------------------------
DisToMark function by Raptorsaurus

Returns the over the ground distance between an object and a marker.

Pass the object and marker name to the function:

_dis = [_obj,_mrk] call DisToMark

or

_dis = [player,"markername"] call DisToMark

Initialize this function by putting this in your init.sqs:
DisToMark = preprocessFile "DisToMark.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_posobj","_posmrk","_xobj","_yobj","_xmrk","_ymrk"];

//get positions

_posobj = getPos (_this select 0);
_posmrk = getMarkerPos (_this select 1);

// pull x and y values from position arrays

_xobj = _posobj select 0;
_yobj = _posobj select 1;

_xmrk = _posmrk select 0;
_ymrk = _posmrk select 1;

// return distance

sqrt( (_xobj-_xmrk)^2 + (_yobj-_ymrk)^2 )
