/*---------------------------------------------------------------
EjectDead function by Raptorsaurus

Ejects dead units from a vehicle

Pass the vehicle to the function as follows:

_dead = [vehicleName] call EjectDead

_dead will an array of the dead units ejected from the vehicle.

Initialize this function by putting this in your init.sqs:
EjectDead = preprocessFile "EjectDead.sqf"
or for a local variable put this at the start of any script using the function:
_EjectDead = preprocessFile "EjectDead.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_craft","_crew","_d","_g","_c","_carg", "_tl", "_tlcarg", "_dead", "_cargoFull];

_craft = _this select 0;
_dead = [];
_carg = [];
_tlcarg = [];
_cargoFull = false;
_crew = crew _craft;
_d = driver _craft;
_g = gunner _craft;
_c = commander _craft;
_carg = _crew - [_d, _g, _c];

//determine driver, gunner, commander status
if ((format ["%1", _d]) != "<NULL-object>" && ! alive _d) then
	{
	_tl = "logic" createVehicle [0,0,0];
	_tl moveInDriver _craft;
	_dead = _dead + [_d];
	unassignVehicle _tl;
	_tl setPos [0,0,0];
	deleteVehicle _tl;
	};
if ((format ["%1", _g]) != "<NULL-object>" && ! alive _g) then
	{		
	_tl = "logic" createVehicle [0,0,0];
	_tl moveInGunner _craft;
	_dead = _dead + [_g];
	unassignVehicle _tl;
	_tl setPos [0,0,0];
	deleteVehicle _tl;
	};
if ((format ["%1", _c]) != "<NULL-object>" && ! alive _c) then
	{
	_tl = "logic" createVehicle [0,0,0];
	_tl moveInCommander _craft;
	_dead = _dead + [_c];
	unassignVehicle _tl;
	_tl setPos [0,0,0];
	deleteVehicle _tl;
	};

//determine cargo status
{if (! alive _x) then {_dead = _dead + [_x]}} forEach _carg;
While {! _cargoFull} Do
	{		
	_tl = "logic" createVehicle [0,0,0];
	_tl moveInCargo _craft;
	if (_tl in _craft) then {_tlcarg = _tlcarg + [_tl]} else {_cargoFull = true; deleteVehicle _tl};
	};
{unassignVehicle _x; _x setPos [0,0,0]; deleteVehicle _x} forEach _tlcarg;
_dead