// CamAngOff function by Raptorsaurus
//ver. 1.0, 7/22/05
//See CamAngOff readme.txt for instructions

private ["_cam","_targ","_prox","_aimoff","_posoff","_postype","_cmit","_targpos","_targdir","_aimpos","_camAbsPos","_camref","_GLref","_SLref","_ASL"];
private ["_xoff","_yoff","_zoff","_x","_y","_z","_alt2","_alt1","_fbx","_fby","_lrx","_lry","_posang","_posdir","_posdis","_rcamX","_rcamY","_rcamZ","_H"];
private ["_camX","_camY","_camZ","_Gasl","_deltaX","_deltaY","_camDir","_aimAng","_aimDir","_aimDis","_rtempZ"];
private ["_raimX","_raimY","_raimZ","_aimX","_aimY","_aimZ","_dirR","_dir","_dis","_camRelPosT","_camRelPosA"];

// get the parameters

_cam = _this select 0;
_targ = _this select 1;
_prox = _this select 2;
_aimoff = _this select 3;
_posoff = _this select 4;
_postype = _this select 5;
_cmit = _this select 6;

_GLref = "logic" createVehicle [0,0,0];
_SLref = "emptydetector" createVehicle [0,0,0];

_targpos = getPos _targ;
_GLref setPos _targpos;
If (_GLref distance _targ > _targpos select 2) then {_targpos = [_targpos select 0, _targpos select 1, _GLref distance _targ]}; 
_targdir = getDir (vehicle _targ);
_aimPos = _targpos;

_camAbsPos = [getPos _cam select 0, getPos _cam select 1, (getPos _cam select 2) - .381104];
_camref = "logic" createVehicle _camAbsPos;

//Find sea level altitude of target

_SLref setPos [_targpos select 0, _targpos select 1];
_ASL = _targ distance _SLref;

// absolute camera position

If (count _posoff == 3 && _postype == 0 ) Then {_camAbsPos = _posoff};

// coordinate relative offset camera position

If (count _posoff == 3 && _postype == 1) Then

	{
	_xoff = _posoff select 0;
	_yoff = _posoff select 1;
	_zoff = _posoff select 2;
	_x = _targpos select 0;
	_y = _targpos select 1;
	_SLref setPos [_x, _y];
	_GLref setPos [_x, _y, 0];
	_alt1 = _GLref distance _SLref;
	_fbX = (_yoff * Sin _targdir);
	_fbY = (_yoff * Cos _targdir);
	_lrX = (_xoff * Sin (_targdir + 90));
	_lrY = (_xoff * Cos (_targdir + 90));
	_SLref setPos [(_fbX + _lrX + _x),(_fbY + _lrY + _y)];
	_GLref setPos [(_fbX + _lrX + _x),(_fbY + _lrY + _y), 0];
	_alt2 = _GLref distance _SLref;
	_zoff = _zoff + (_alt1 - _alt2);
	_z = (_targpos select 2) + _zoff;
	_camAbsPos = [(_fbX + _lrX + _x),(_fbY + _lrY + _y), _z];
	};

// angular relative offset camera position

if (count _posoff == 3 && _postype == 2) then

	{
	_posang = _posoff select 0;
	_posdir = _posoff select 1;
	_posdis = _posoff select 2;
	_rcamZ = _posdis * Sin _posang;
	_H = _posdis * Cos _posang;
	_rcamX = _H * Sin _posdir;
	_rcamY = _H * Cos _posdir;
	_camX = (_targpos select 0) + (_rcamY * Sin _targdir) + (_rcamX * Sin (_targdir + 90));
	_camY = (_targpos select 1) + (_rcamY * Cos _targdir) + (_rcamX * Cos (_targdir + 90));
	_GLref setPos [_camX, _camY, 0];
	_SLref setPos [_camX, _camY];
	_Gasl = _GLref distance _SLref;
	_camZ = (_ASL - _Gasl) + _rcamZ;
	_camAbsPos = [_camX, _camY, _camZ];
	};

// set _camref to face target

_camref SetPos _camAbsPos;
_deltaX = (_targpos select 0) - (getPos _camref select 0);
_deltaY = (_targpos select 1) - (getPos _camref select 1);
if (_deltaY == 0) then {_deltaY = .0000001};
_camDir = (atan (_deltaX / _deltaY));
if (_deltaY < 0) then {_camDir = _camDir + 180};
if (_camDir < 0) then {_camDir = _camDir + 360};
_camref SetDir _camDir;

// caluculate angular aimpoint offset

If (count _aimoff == 2) Then

	{
	_aimAng = _aimoff select 0;
	_aimDir = _aimoff select 1;
	_aimDis = _camref distance _targ;
	_raimZ = _aimdis * Sin _aimAng;
	_H = _aimDis * Cos _aimAng;
	_raimX = _H * Sin _aimDir;
	_raimY = _H * Cos _aimDir;
	_aimX = (_camAbsPos select 0) + (_raimY * Sin _camDir) + (_raimX * Sin (_camDir + 90));
	_aimY = (_camAbsPos select 1) + (_raimY * Cos _camDir) + (_raimX * Cos (_camDir + 90));
	_GLref setPos [_aimX, _aimY, 0];
	_SLref setPos [_aimX, _aimY];
	_Gasl = _GLref distance _SLref;
	_aimZ = (_ASL - _Gasl)  + _raimZ;
	_aimPos = [_aimX, _aimY, _aimZ];
	};

// calculate coordinate aimpoint offset

If (count _aimoff == 3) Then

	{
	_xoff = _aimoff select 0;
	_yoff = _aimoff select 1;
	_zoff = _aimoff select 2;
	_x = _targpos select 0;
	_y = _targpos select 1;
	_SLref setPos [_x, _y];
	_GLref setPos [_x, _y, 0];
	_alt1 = _GLref distance _SLref;
	_fbX = (_yoff * Sin _targdir);
	_fbY = (_yoff * Cos _targdir);
	_lrX = (_xoff * Sin (_targdir + 90));
	_lrY = (_xoff * Cos (_targdir + 90));
	_SLref setPos [(_fbX + _lrX + _x),(_fbY + _lrY + _y)];
	_GLref setPos [(_fbX + _lrX + _x),(_fbY + _lrY + _y), 0];
	_alt2 = _GLref distance _SLref;
	_altdif = _alt1 - _alt2;
	_zoff = _zoff + _altdif;
	_z = (_targpos select 2) + _zoff;
	_aimPos = [(_fbX + _lrX + _x),(_fbY + _lrY + _y),_z];
	};

// set _prox target at _aimPos

_prox setPos _aimPos;
_prox setDir (getDir (vehicle _targ));

// calculate the relative position of the camera from the target

_camRelPosT = _posoff;
if (_postype != 1)
	then
	{
	_SLref setPos [getPos _targ select 0, getPos _targ select 1];
	_rtempZ = _targ distance _SLref;
	_SLref setPos [getPos _camref select 0, getPos _camref select 1];
	_rcamZ = _camref distance _SLref;
	_dirR = getDir _targ;
	_deltaX = (getpos _camref select 0) - (getpos _targ select 0);
	_deltaY = (getpos _camref select 1) - (getpos _targ select 1);
	if (_deltaY == 0) then {_deltaY = .0000001};
	_dir = _deltaX atan2 _deltaY;
	_dir = -(_dirR - _dir);
	_dis = sqrt (_deltaX ^2 + _deltaY ^2);
	_xoff = _dis * sin _dir;
	_yoff = _dis * cos _dir;
	_zoff = _rcamZ - _rtempZ;
	_camRelPosT = [_xoff,_yoff,_zoff];
	};
	
// calculate the relative position of the camera from the aimpoint

_camRelPosA = _posoff;
if (count _aimoff >= 2)
	then
	{
	_SLref setPos [getPos _prox select 0, getPos _prox select 1];
	_rtempZ = _prox distance _SLref;
	_SLref setPos [getPos _camref select 0, getPos _camref select 1];
	_rcamZ = _camref distance _SLref;
	_dirR = getDir _prox;
	_deltaX = (getpos _camref select 0) - (getpos _prox select 0);
	_deltaY = (getpos _camref select 1) - (getpos _prox select 1);
	if (_deltaY == 0) then {_deltaY = .0000001};
	_dir = _deltaX atan2 _deltaY;
	_dir = -(_dirR - _dir);
	_dis = sqrt (_deltaX ^2 + _deltaY ^2);
	_xoff = _dis * sin _dir;
	_yoff = _dis * cos _dir;
	_zoff = _rcamZ - _rtempZ;
	_camRelPosA = [_xoff,_yoff,_zoff];
	};

deleteVehicle _GLref;
deleteVehicle _SLref;
deleteVehicle _camref;

if (count _aimoff >= 2) then
	{
	_cam camSetTarget _prox;
	if (_postype == 1 || _postype == 2) then {_cam camSetRelPos _camRelPosA} else {_cam camSetPos _camAbsPos};
	};
if (count _aimoff < 2) then
	{
	_cam camSetTarget _targ;
	if (_postype == 1 || _postype == 2) then {_cam camSetRelPos _camRelPosT} else {_cam camSetPos _camAbsPos};
	};
_cam camcommit _cmit;

// absolute and relative position values

[_camAbsPos, _camRelPosT, _camRelPosA, _aimpos]