//CamDualTarg function by Raptorsaurus
//v. 1.0, 2/22/06
//See Functions Notes.txt

private ["_nt","_ft","_os","_tDir","_tDis","_tAng", "_oDir", "_oAlt", "_X", "_Y", "_Z", "_H", "_GLref", "_vWidth"];
private ["_dis","_SLref","_ftASL","_ntASL","_Dalt", "_Dx", "_Dy", "_Cpos", "_Apos", "_dir", "_ang", "_camASL", "_FOV"];

_nt = _this select 0;
_ft = _this select 1;
_os = _this select 2;

_oDir = _os select 0;
if (abs _oDir < 90) then {_oDir = 180 - _oDir};
_dis = _os select 1;
_oAlt = _os select 2;
if (abs _oAlt > _dis) then {_oAlt = _dis};

_SLref = "emptydetector" camCreate [0,0,0];
_GLref = "logic" camcreate [0,0,0];
_camref = "logic" camcreate [0,0,0];

// get ASL altitude info

_SLref setPos [getPos _ft select 0, getPos _ft select 1];
_ftASL = _ft distance _SLref;
_SLref setPos [getPos _nt select 0, getPos _nt select 1];
_ntASL = _nt distance _SLref;

// calculate the compass direction of the line formed by the two targets

_Dx = (getPos _ft select 0) - (getPos _nt select 0);
_Dy = (getPos _ft select 1) - (getPos _nt select 1);

if (_Dy == 0) then {_Dy = .0000001};

_tDir = _Dx atan2 _Dy;
if (_tDir < 0) then {_tDir = _tDir + 360};

// calculate the direction to the intended camera position

_dir = _tDir + _oDir;
if (_dir < 0) then {_dir = _dir + 360};
if (_dir > 360) then {_dir = _dir - 360};

// calculate horizontal distance component from _nt to intended camera pos

_ang = Asin (_oAlt/_dis);
_H = _dis * cos _ang;

// calculate _X and _Y coordinates

_X = (getPos _nt select 0) + (_H * Sin _dir);
_Y = (getPos _nt select 1) + (_H * Cos _dir);

//Find _Z compensating for Sea Level Alt of the ground at the x,y position.

_GLref setPos [_X, _Y, 0];
_SLref setPos [_X, _Y];
_Z = (_ntASL - (_GLref distance _SLref)) + _oAlt;

if (_Z < 0) then {_Z = 0};

_Cpos = [_X, _Y, _Z];

//Find direction and angle from _cpos to _ft

_SLref setPos [_X, _Y];
_camref setPos _Cpos;
_camASL = _camref distance _SLref;

_Dx = (getPos _ft select 0) - _X;
_Dy = (getPos _ft select 1) - _Y;
if (_Dy == 0) then {_Dy = .0000001};
_tDir = _Dx atan2 _Dy;
if (_tDir < 0) then {_tDir = _tDir + 360};

_Dalt = _ftASL - _camASL;
_tDis = _camref Distance _ft;

if (_tDis == 0) then {_tDis = .0000001};
_tAng = Asin (_Dalt/_tDis);

//Find direction and angle from _cpos to _nt

_oDir = _dir + 180;
if (_oDir > 360) then {_oDir = _oDir - 360};
_ang = -_ang;

// calculate direction and angle from _Cpos to nominal aimpoint

if ( abs (_tDir - _oDir) > 180) then { if (_oDir < _tDir) then {_oDir = _oDir + 360} else {_tDir = _tDir + 360} };
_dir = (_tDir + _oDir) / 2;
_ang = (_tAng + _ang) / 2;

// calculate vertical position offset

_Z = _dis * Sin _ang;

// calculate horizontal distance component

_H = _dis * Cos _ang;

// calculate _X and _Y coordinates

_X = _X + (_H * Sin _dir);
_Y = _Y + (_H * Cos _dir);

//Find _Z compensating for Sea Level Alt of the ground at the x,y posistion.

_GLref setPos [_X, _Y, 0];
_SLref setPos [_X, _Y];
_Z = (_camASL - (_GLref distance _SLref)) + _Z;

_Apos = [_X, _Y, _Z];

//Find _vWidth between targets and _FOV

_GLref setPos _Apos;
_vWidth = 2 * (_GLref distance _nt);

_FOV = _vWidth / _dis;

deleteVehicle _GLref;
deleteVehicle _SLref;
deleteVehicle _camref;

[_Cpos, _Apos, _FOV]