/*---------------------------------------------------------------
GetPosOffset function by Raptorsaurus

This function finds the positional offset of an object relative to another object
in coordinate format [Xoffset, Yoffset, Zoffset].  In other words, it tells you how
far to the left/right it is (negative is to left), how far in front or behind it is (negative is behind)
and how far above or below it is (negative is below).

Parameters passed to function:

Reference object name
Name of object to find offest posistion from reference object
                
Example:

_refobj = _car
_targobj = _man

_offset = [_refobj,_targobj] call GetPosOffset

Initialize this function by putting this in your init.sqs:
GetPosOffset = preprocessFile "GetPosOffset.sqf"
---------------------------------------------------------------*/

// declare private variables

private ["_robj" , "_tobj" , "_dirR", "_dis", "_offX", "_offY","_offZ","_dir", "_Zref","_Zrobj", "_Ztobj", "_dX", "_dY"];

_robj = _this select 0;
_tobj = _this select 1;

_Zref = "emptydetector" createVehicle [0,0,0];
_Zref setPos [getPos _robj select 0, getPos _robj select 1];
_Zrobj = _robj distance _Zref;
_Zref setPos [getPos _tobj select 0, getPos _tobj select 1];
_Ztobj = _tobj distance _Zref;

deleteVehicle _Zref;

_dirR = getDir (vehicle _robj);
_dX = (getPos _tobj select 0) - (getPos _robj select 0);
_dY = (getPos _tobj select 1) - (getPos _robj select 1);

if (_dY == 0) then {_dY = .0000001};

_dir = _dX atan2 _dY;
_dir = -(_dirR - _dir);
_dis = sqrt (((getpos _tobj select 0) - (getpos _robj select 0))^2 + ((getpos _tobj select 1) - (getpos _robj select 1))^2);

_offX = _dis * sin _dir;
_offY = _dis * cos _dir;
_offZ = _Ztobj - _Zrobj;

[_offX,_offY,_offZ]