/*---------------------------------------------------------------
GridCoord function by uiox

Given a position, this function will return the alpha-numeric map grid
coordinates in the AaXX format.

Example: _mapPos = [getPos player] call GridCoord
If the player is at the highest altitude point of the Desert Island map
(the peak which is 51 m above sea level) _mapPos = "Id66". If the player
is in the town of Trosky on the island of Nogova _mapPos = "Gc25".

Initialize this function by putting this in your init.sqs:
GridCoord = preprocessFile "GridCoord.sqf"
or this at the start of a script using this function:
_GridCoord = preprocessFile "GridCoord.sqf"
---------------------------------------------------------------*/

private ["_result","_GrandeLettre","_PetiteLettre","_Chiffre", "_Chiffrestring","_Pos","_ArrayMajuscForGrid","_ArrayMinusForGrid " ];

_ArrayMajuscForGrid = ["A","B","C","D","E","F","G","H","I","J"];
_ArrayMinusForGrid = ["a","b","c","d","e","f","g","h","i","j"];

_Pos = _This select 0;
_Chiffrestring ="";
_result = "";
_GrandeLettre = (((_Pos select 0) - ((_Pos select 0) Mod 1280))/1280);                             
_PetiteLettre =((((_Pos select 0) Mod 1280)- (((_Pos select 0) Mod 1280)Mod 128))/128);   
_Chiffre = (99 - ((_Pos select 1) - ((_Pos select 1) Mod 128))/128);         
_Chiffrestring = Format["%1",_Chiffre];
If (_Chiffre < 10) then  {_Chiffrestring = "0" + _Chiffrestring };
_result = ((_ArrayMajuscForGrid select _GrandeLettre) + ( _ArrayMinusForGrid select _PetiteLettre) +_Chiffrestring);

_result



