/*---------------------------------------------------------------
HorzVel function by Raptorsaurus

Returns the Horizontal velocity of an object (the resultant magnitude of
its x & y rectangular velociy components).  For example a missile's speed
may be 900 m/s but if it is going up at a 45 deg angle its Hvel(volocity
over the ground) will be 636.396 m/s.

Call this command by passing the object to the function:

_HVel = [_obj] call HorzVel

Initialize this function by putting this in your init.sqs:
HorzVel = preprocessFile "HorzVel.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_vel","_x","_y"];

_vel = Velocity (_this select 0);

// get the rectangular velocity vector components

_x = _vel select 0;
_y = _vel select 1;

// get the Hvel

sqrt(_x^2 + _y^2)
