/*---------------------------------------------------------------
ObjElevObj function by Raptorsaurus

Finds the elevation angle from one object to another

Pass info to the function in the following format:

[_robj, _tobj] call ObjElevObj


Initialize this function by putting this in your init.sqs:
ObjElevObj  = preprocessFile "ObjElevObj.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_robj","_tobj","_vdis","_dis","_Zref", "_Zrobj", "_Ztobj"];

_robj = _this select 0;
_tobj = _this select 1;

_dis = _robj distance _tobj;

// get vertical distance between objects

_Zref = "emptydetector" createVehicle [0,0,0];
_Zref setPos [getPos _robj select 0, getPos _robj select 1];
_Zrobj = _robj distance _Zref;
_Zref setPos [getPos _tobj select 0, getPos _tobj select 1];
_Ztobj = _tobj distance _Zref;
deleteVehicle _Zref;
_vdis = _Ztobj - _Zrobj;
if (_dis < abs _vdis) then {_dis = abs _vdis};

// calculate angle elevation as return value

Asin (_vdis / _dis)