/*---------------------------------------------------------------
PosDisPos function by Raptorsaurus
v. 1.0

Returns the distance between two positions. If either postion value is
3 dimensional, then the distance will be 3D.  If BOTH postion values are
2 dimensional, then the distance will be 2D.

The required info passed to this function is:

- Position A [x,y,z] or [x,y]
- Position B [x,y,z] or [x,y]

_dis = [pos1, pos2] call PosDisPos

_dis will be the distance between the two postions.

Initialize this function by putting this in your init.sqs:
PosDisPos = preprocessFile "PosDisPos.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_pos1", "_pos2", "_ref1", "_ref2", "_dis"];

// get the parameters

_pos1 = _this select 0;
_pos2 = _this select 1;

if (count _pos1 == 3 || count _pos2 == 3) then
	{
	_ref1 = "logic" createVehicle [0,0,0];
	_ref2 = "logic" createVehicle [0,0,0];
	};
if (count _pos1 == 2 && count _pos2 == 2) then
	{
	_ref1 = "emptydetector" createVehicle [0,0,0];
	_ref2 = "emptydetector" createVehicle [0,0,0];
	};
_ref1 setPos _pos1;
_ref2 setPos _pos2;
_dis = _ref1 distance _ref2;
deleteVehicle _ref1;
deleteVehicle _ref2;
_dis
