/*---------------------------------------------------------------
PosDisToMk function by Raptorsaurus

Returns the over the ground distance between a position [x,y] and a marker.

Pass the position and marker name to the function:

_dis = [_pos,_mrk] call PosDisToMk

or

_dis = [[_x,_y],"markername"] call PosDisToMk

Initialize this function by putting this in your init.sqs:
PosDisToMk = preprocessFile "PosDisToMk.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_pos","_posmrk","_xpos","_ypos","_xmrk","_ymrk"];

//get positions

_pos = _this select 0;
_posmrk = getMarkerPos (_this select 1);

// pull x and y values from position arrays

_xpos = _pos select 0;
_ypos = _pos select 1;

_xmrk = _posmrk select 0;
_ymrk = _posmrk select 1;

// return distance

sqrt((_xpos-_xmrk)^2 + (_ypos-_ymrk)^2)
