/*---------------------------------------------------------------
BP function by Raptorsaurus

Returns an array with the first element being the Bank of a vehicle and the second element
being the Pitch of the vehicle.  This function is initialized and called exclusively from the
script getBankPitch.sqs.  For information on how to use this function see the instructions
in MonitorBP.sqs.
---------------------------------------------------------------*/
private ["_SLref", "_TPref", "_altC", "_pc", "_pl", "_pr", "_pf", "_pb", "_cnt", "_rd", "_d", "_c", "_rc", "_doff"];
private ["_bk", "_pch", "_GDref", "_gdis", "_Dalt", "_Dx", "_Dy", "_pp", "_craft", "_dir", "_bear", "_ang1", "_ang2"];
_pc = _this select 0;
_pr = _this select 1;
_pf = _this select 2;
_pp = _this select 3;
_SLref = "emptyDetector" createVehicle [0,0,0];
_GDref = "emptyDetector" createVehicle [0,0,0];
_TPref = "logic" createVehicle [0,0,0];
_PPref = "logic" createVehicle [0,0,0];
_GDref setPos [_pc select 0, _pc select 1];
_SLref setPos [_pc select 0, _pc select 1];
_TPref setPos _pc;
_altC = _SLref distance _TPref;
_a = RPT_BParray;
_cnt = 0;
_rc = 0;
_rd = 999999;
While {_cnt < count _a}
Do
	{
	_c = (_a select _cnt) select 0;
	_SLref setPos [getPos _c select 0, getPos _c select 1];
	_Dalt = _altC - (_c distance _SLref);
	_gdis = sqrt ( ((getPos _c select 0) - (_pc select 0)) ^2 + ((getPos _c select 1) - (_pc select 1)) ^2 );
	_d = sqrt (_gdis ^2 + _Dalt ^2);
	if (_d < _rd) then {_rc = _cnt; _rd = _d; _craft = _c};
	_cnt = _cnt + 1;
	};
_dir = getDir _craft; 
_Dx = (_pp select 0) - (_pc select 0);
_Dy = (_pp select 1) - (_pc select 1);
if (_DX != 0 || _Dy != 0) then {_bear = _Dx atan2 _Dy} else {_bear = 0};
if (_bear < 0) then {_bear = _bear + 360};
_ang1 = _dir;
_ang2 = _bear;
if ((_ang1 - _ang2) > 180) then {_ang2 = _ang2 + 360};
if ((_ang2 - _ang1) > 180) then {_ang1 = _ang1 + 360};
_doff = (_ang2 - _ang1);
_SLref setPos [_pr select 0, _pr select 1];
_gdis = _SLref distance _GDref;
_bk = acos (_gdis);
if (_doff > 0) then {_bk = -_bk};
if (format ["%1", _bk] == "-1.#IND" || format ["%1", _bk] == "1.#QNAN") then {_bk = 0}; 
_SLref setPos [_pf select 0, _pf select 1];
_gdis = _SLref distance _GDref;
_pch = acos (_gdis);
if (abs _doff > 90) then {_pch = -_pch};
if (format ["%1", _pch] == "-1.#IND" || format ["%1", _pch] == "1.#QNAN") then {_pch = 0};
deleteVehicle _SLref;
deleteVehicle _GDref;
deleteVehicle _TPref;
deleteVehicle _PPref;
_a = RPT_BParray select _rc;
_a set [1, _bk];
_a set [2, _pch];