/*---------------------------------------------------------------
BankPitch function by Raptorsaurus

Returns a two dimensional array containing the bank and pitch of a vehicle.
See instructions after code.
---------------------------------------------------------------*/

// declare private variables
private ["_u", "_a", "_c", "_t", "_b", "_p", "_cnt"];

_u = _this;
_t = false;
_a = RPT_BParray;
_cnt = 0;
While {_cnt < count _a}
Do
	{
	_c = (_a select _cnt) select 0;
	if (_u == _c) then
		{
		_b = (_a select _cnt) select 1;
		_p = (_a select _cnt) select 2;
		_t = true;
		_cnt = count _a;
		};
	_cnt = _cnt + 1;
	};
if (! _t) then {_b = "--"; _p = "--"};
[_b, _p]

/*---------------------------------------------------------------
Usage instructions:

Pass info to the function in the following format:

_BP = _craft call BankPitch

_BP will contain:

_Bank = _BP select 0   (The bank of _craft)
_Pitch = _BP select 1   (The pitch of _craft)

Note: This function is only usable in conjunction with the RPT_BankPitch suite of script and functions.
---------------------------------------------------------------*/