/*---------------------------------------------------------------
RandElem function by Raptorsaurus
ver. 1.0

This function returns a random element from an array of elements.

Examples

Eg. 1:
_array = [123, 342, 12, 15, 1]
_randelem = [_array] call RandElem

This will randomly return one of the numbers in _array

Eg. 2:
_posarray = [[1234, 123, 5], [1237, 3456, 23], [9348, 1947, 56]]
_randpos = [_posarray] call RandElem

This will randomly return on of the positions in _possarray

Initialize this function by putting this in your init.sqs:
RandElem = preprocessFile "RandElem.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_array","_num","_cnt"];
_array = _this select 0;
_cnt = (count _array) - 1;

// select random element from array (compensates for rounding factor causing high and low values from having lower chance).
_num = (random ((_cnt + .5) - (0 - .5))) + (0 - .5);

// make sure number is integer value
_num = (_num + .5) - ((_num + .5) % 1);

// return the array element
_array select _num