/*---------------------------------------------------------------
RelSpd function by Raptorsaurus

Returns the speed of one vehicle relative to a second vehicle

Pass the two vehicles and reference position offset for the second vehicle

_rspd = [_veh1, _veh2, [-20, 20, 10] call RelSpd

_rspd will be the speed in k/h at which _veh1 is approaching the position 20 m left, 20 m behind and 10 m
above _veh2.

Initialize this function by putting this in your init.sqs:
RelSpd = preprocessFile "RelSpd.sqf"
or locally in a script:
_RelSpd = preprocessFile "RelSpd.sqf"
---------------------------------------------------------------*/

Private ["_lead","_chase","_poff", "_Rspd", "_SLref", "_TPref", "_SLref2", "_alt1", "_alt2", "_dis", "_Refdir"];
private ["_Refpos", "_x", "_y", "_z", "_offFB", "_offLR", "_offAB", "_leadX", "_leadY", "_cpnt", "_leewX","_leewY"];
_lead = _this select 0;
_chase = _this select 1;
_poff = _this select 2;
_SLref = "emptyDetector" createVehicle [0,0,0];
_SLref2 = "emptyDetector" createVehicle [0,0,0];
_TPref = "logic" createVehicle [0,0,0];
_offLR = _poff select 0;
_offFB = _poff select 1;
_offAB = _poff select 2;
_Refdir = getDir _lead;
_Refpos = getPos _lead;
_x = _Refpos select 0;
_y = _Refpos select 1;
_SLref setPos [_x, _y];
_TPref setPos [_x, _y, 0];
_alt1 = _TPref distance _SLref;
_leadX = (_offFB * Sin _Refdir);
_leadY = (_offFB * Cos _Refdir);
_leewX = (_offLR * Sin (_Refdir + 90));
_leewY = (_offLR * Cos (_Refdir + 90));
_SLref setPos [(_leadX + _leewX + _x),(_leadY + _leewY + _y)];
_TPref setPos [(_leadX + _leewX + _x),(_leadY + _leewY + _y), 0];
_alt2 = _TPref distance _SLref;
_offAB = _offAB + (_alt1 - _alt2);
_z = (_Refpos select 2) + _offAB;
_cpnt = [(_leadX + _leewX + _x),(_leadY + _leewY + _y),_z];
_TPref setPos _cpnt;
_dis = _chase distance _TPref;
_SLref setPos [_cpnt select 0, _cpnt select 1];
_z = _SLref distance _TPref;
_x = (velocity _lead select 0) + (_cpnt select 0);
_y = (velocity _lead select 1) + (_cpnt select 1);
_z = (velocity _lead select 2) + _z;
_SLref setPos [_x, _y, _z];
_SLref2 setPos [getPos _chase select 0, getPos _chase select 1];
_z = _chase distance _SLref2;
_x = (velocity _chase select 0) + (getPos _chase select 0);
_y = (velocity _chase select 1) + (getPos _chase select 1);
_z = (velocity _chase select 2) + _z;
_SLref2 setPos [_x, _y, _z];
_Rspd = _dis - (_SLref distance _SLref2);
deleteVehicle _SLref;
deleteVehicle _SLref2;
deleteVehicle _TPref;
_Rspd * 3600 / 1000