/*---------------------------------------------------------------
RndOff function by Raptorsaurus

This function returns a number rounded to the user defined precision

Examples

Eg. 1:
_num = [_num, .05] call RndOff

This will return _num rounded to the nearest 0.05

Eg. 2:
_num = [_num,.1] call RndOff

This will return _num rounded to the nearest 0.1

Eg. 3:
_num = [_num,1] call RndOff

This will return _num rounded to the nearest integer value

Eg. 4:
_num = [_num,10] call RndOff

This will return _num rounded to the nearest 10

Initialize this function by putting this in your init.sqs:
RndOff = preprocessFile "RndOff.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_rnd","_num"];

_num = _this select 0;
_rnd = _this select 1;

// Round _num to requested precision

(_num + (_rnd/2)) - ((_num + (_rnd/2)) % _rnd)