/*---------------------------------------------------------------
setMkDisAngMk function by Raptorsaurus

Places a marker at certain distance and angle (compass heading) from another
marker.  Also sets the marker type and color.

Pass info to the function in the following format:

[_RefMk,_PlcMk,_Dis,_Ang,_Typ,_Col] call setMkDisAngMk

or

["RefMarker","MarkertoPlace",250,45,"Dot","Colorblue"] call setMkDisAngMk

Initialize this function by putting this in your init.sqs:
setMkDisAngMk = preprocessFile "setMkDisAngMk.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_posRef","_Mk","_x1","_y1","_dis","_ang","_typ","_col"];

//get info

_posRef = getMarkerPos (_this select 0);
_Mk = _this select 1;
_dis = _this select 2;
_ang = _this select 3;
_typ = _this select 4;
_col = _this select 5;

// get x & y coordinates from refMarker

_x1 = _posRef select 0;
_y1 = _posRef select 1;

_Mk setMarkerPos [(_x1 + (_dis * Sin _ang)),(_y1 + (_dis * Cos _ang))];
_Mk setMarkerType _typ;
_Mk setMarkerColor _col;
