/*---------------------------------------------------------------
setObDisDirAngOb function by Raptorsaurus

Set positions an object at certain distance, compass direction
and elevation angle from another object.  It also sets the objects
compass heading in the direction called and corrects for sea level.
The function will also return the position of the placed object.

Pass info to the function in the following format:

[_RefOb,_PlcOb,_Dis,_Dir,_Ang] call setObDisDirAngOb


Initialize this function by putting this in your init.sqs:
setObDisDirOb = preprocessFile "setObDisDirAngOb.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_refobj","_plcobj","_x1","_y1","_dis","_ang","_dir","_SLref","_ASL","_x2","_y2","_z","_GLref","_zoff","_hdis"];

//get info

_refobj = _this select 0;
_plcobj = _this select 1;
_dis = _this select 2;
_dir = _this select 3;
_ang = _this select 4;

// get x & y coordinates from refObject

_x1 = (getPos _refobj) select 0;
_y1 = (getPos _refobj) select 1;
_z = (getPos _refobj) select 2;

_hdis = _dis * Cos _ang;
_x2 = _x1 + (_hdis * Sin _dir);
_y2 = _y1 + (_hdis * Cos _dir);
_zoff = _dis * Sin _ang;

//Find sea level altitude of _refobj

_SLref = "emptydetector" createVehicle [0,0,0];
_GLref = "logic" createVehicle [0,0,0];
_GLref setPos [_x1, _y1, _z];
_SLref setPos [_x1, _y1];
_ASL = _GLref distance _SLref;

//Determine _z correcting for _ASL

_GLref setPos [_x2, _y2, 0];
_SLref setPos [_x2, _y2];
_z = _zoff + (_ASL - (_GLref distance _SLref));

deleteVehicle _GLref;
deleteVehicle _SLref;

_plcobj setPos [_x2,_y2,_z];
_plcobj setDir _dir;
[_x2, _y2, _z]