/*---------------------------------------------------------------
setObDisDirOb function by Raptorsaurus

Set positions an object at certain distance and direction
(compass heading) from another object.  Also sets the objects
compass heading in the direction called. If the last parameter
is set to true then the function will correct to sea level. The
function will also return the position of the placed object.

Pass info to the function in the following format:

[_RefOb,_PlcOb,_Dis,_Ang,_Dir, true] call setObDisDirOb


Initialize this function by putting this in your init.sqs:
setObDisDirOb = preprocessFile "setObDisDirOb.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_refobj","_plcobj","_x1","_y1", "_dis","_ang","_dir", "_SL", "_SLref", "_ASL", "_x2", "_y2", "_z2", "_GLref"];

//get info

_refobj = _this select 0;
_plcobj = _this select 1;
_dis = _this select 2;
_ang = _this select 3;
_dir = _this select 4;
_SL = _this select 5;

// get x & y coordinates from refObject

_x1 = (getPos _refobj) select 0;
_y1 = (getPos _refobj) select 1;
_z = (getPos _refobj) select 2;

_x2 = _x1 + (_dis * Sin _ang);
_y2 = _y1 + (_dis * Cos _ang);

//Find sea level altitude of the ground at the _refobj position

_SLref = "emptydetector" camcreate [0,0,0];
_GLref = "logic" camcreate [0,0,0];
_GLref setPos [_x1, _y1, _z];
_SLref setPos [_x1, _y1];
_ASL = _GLref distance _SLref;

//Find Sea Level Alt of the ground at the _x2,_y2 posistion and compensate for _z

_GLref setPos [_x2, _y2, 0];
_SLref setPos [_x2, _y2];
_z = 0;
if (_SL) then {_z = (_ASL - (_GLref distance _SLref))};

deleteVehicle _GLref;
deleteVehicle _SLref;

_plcobj setPos [_x2,_y2, _z];
_plcobj setDir _dir;
[_x2, _y2, _z]