/*---------------------------------------------------------------
SetPosOffset function by Raptorsaurus

This function sets an object at an offset position releative to
another object in absolute coordinate format (ie. not ralative to any direction
that either objcect is facing).  This function works in conjunction with GetPosOffset
If you want ot place an object relative to another obeject and relative to its direction,
then  use SetObDisAngOb.sqf or SetObjPosObj.sqf.

Parameters passed to function:

Reference object name
Name of object to place
Position offset
                
Example:

_refobj = _car
_setobj = _man
_posoff = [5,5,0]

_pos = [_refobj,_setobj,_posoff] call SetPosOffset

This will place the _man 5 meters to the West of the car, 5 meters to the North
of the car and at the same ground level as the car and _pos will be the new position value.

Initialize this function by putting this in your init.sqs:
SetPosOffset = preprocessFile "SetPosOffset.sqf"
---------------------------------------------------------------*/

// declare private variables

private ["_robj" , "_pobj" , "_offX" , "_offY" , "_offZ" , "_posOff" , "_pos"];

_robj = _this select 0;
_pobj = _this select 1;
_posOff = _this select 2;

_offX = (getPos _robj select 0) + (_posOff select 0);
_offY = (getPos _robj select 1) + (_posOff select 1);
_offZ = (getPos _robj select 2) + (_posOff select 2);

_pos = [_offX,_offY,_offZ];
_pobj setPos _pos;
_pos