/*---------------------------------------------------------------
TrueSpd function by Raptorsaurus
v. 1.0, May 25, 2006

Find the true speed of a vehicle in k/h always as a positive value.

The required info passed to this function is:

- The vehicle for which the true speed is desired

Example:

_vehicle = vehicle player

[_vehicle] call TrueSpd

This will return the true positive speed of the player's vehicle (if it is moving in reverse or only up or down it will
still be a positive value).

Initialize this function by putting this in your init.sqs:
TrueSpd = preprocessFile "TrueSpd.sqf"
or as a local value in a script use:
_TrueSpd = preprocessFile "TrueSpd.sqf"
---------------------------------------------------------------*/

Private ["_veh","_Hvel","_Zvel","_ang","_spd"];
_veh = _this select 0;
_Hvel = sqrt((velocity _veh select 0)^2 + (velocity _veh select 1)^2);
_Zvel = (velocity _veh select 2);
If (_Hvel != 0)
then
{
  _ang = Atan (_Zvel/_Hvel);
  _spd = (_Hvel / Cos _ang) * 3600 / 1000;
}
Else
{
  _spd = (abs _Zvel) * 3600 / 1000;
};
_spd