/*---------------------------------------------------------------
VelAng function by Raptorsaurus

Returns an object's velocity angle from horizontal, ie. the angle of climb
(positive angle) or the angle of decent (negative angle) of a projectile
or aircraft.

Pass object to function:

_VAng = [_obj] call VelAng

Initialize this function by putting this in your init.sqs:
VelAng = preprocessFile "VelAng.sqf"
---------------------------------------------------------------*/

// declare private variables
private ["_vel","_x","_y","_z","_Hvel","_Ang"];

_vel = Velocity (_this select 0);

_x = _vel select 0;
_y = _vel select 1;
_z = _vel select 2;

// convert to magnitued & angle format

_Hvel = sqrt(_x^2 + _y^2);

If (_Hvel == 0) then
{
  If (_z > 0) then {_Ang = 90};
  If (_z < 0) then {_Ang = -90};
  If (_z == 0) then {_Ang = 0};
};
If (_Hvel != 0) then {_Ang = Atan (_z/_Hvel)};
_Ang