/*---------------------------------------------------------------
knowers.sqf function by Raptorsaurus
v. 1.01, 08/24/06 (added check for enemies in vehicles)

See instructions in "knowers & knowns readme".
------------------------------------------------------------------*/

private ["_unit", "_enems","_cnt","_kmin","_knowers","_knowns","_krec","_cnt2"];
private ["_list","_elem", "_elemrec", "_knower", "_known","_leads","_erec","_friends", "_enemies"];

_friends = _this select 0;
_enemies = _this select 1;
_kmin = _this select 2;

//make sure only living units are in array pools and reduce _friends to group leaders (since knowlege is equal within groups)
_leads = [];
{ if ( (_x == leader (group _x)) && (alive _x) ) then {_leads = _leads + [_x]} } forEach _friends;
_enems = [];
{ if (alive _x) then {_enems = _enems + [_x]} } forEach _enemies;

//make array of leaders who know at least _kmin about an enemy who is not captive

_knowers = [];
_cnt = 0;
While {_cnt < count _leads}
Do
	{
	_unit = _leads select _cnt;
	if ( {(_unit knowsAbout (vehicle _x)) >= _kmin && ! captive (vehicle _x)} count _enems > 0) then { _knowers = _knowers + [_unit] };
	_cnt = _cnt + 1;
	};

//make array of enemies who are known at least _kmin by a _knower & not captive

_knowns = [];
_cnt = 0;
While {_cnt < count _enems && count _knowers > 0}
Do
	{
	_unit = _enems select _cnt;
	if ( {(_x knowsAbout (vehicle _unit)) >= _kmin && ! captive (vehicle _unit)} count _knowers > 0) then { _knowns = _knowns + [vehicle _unit]};
	_cnt = _cnt + 1;
	};

// Make knowers array list

_list = [];
_cnt = 0;
While {_cnt < count _knowers}
Do
	{
	_unit = _knowers select _cnt;
	_krec = 0;
	_cnt2 = 0;
	While {_cnt2 < count _knowns}
	Do
		{
		_know = _unit knowsAbout (_knowns select _cnt2);
		if ( _know > _krec )
		then 
			{
			_list set [_cnt , [_unit, (_knowns select _cnt2) , _know] ];
			_krec = _know;
			};
		_cnt2 = _cnt2 + 1;
		};
	_cnt = _cnt + 1;
	};

//Sort knowers array list

_knowersList = [];
_cnt2 = 0;
While {_cnt2 < count _list}
Do
	{
	_krec = 0;
	_erec = 0;
	_elem = [];
	_cnt = 0;
	While {_cnt < count _list}
	Do
		{
		_elem = _list select _cnt;
		if ( (_elem select 2) > _krec )
		then 
			{
			_knowersList set [_cnt2 , _elem];
			_krec = (_elem select 2);
			_erec = _cnt;
			};
		_cnt = _cnt + 1;
		};
	_list set [_erec, ["","",0]];
	_cnt2 = count _knowersList;
	};
_knowersList