//Improved Nearest Object v1.0
//By General Barron
//aw_barron@hotmail.com
//10/1/03

//This function works almost exactly like the normal nearestObject command, however 
//this finds the nearest object out of a number of object types, instead of just one object type.
//It is called as follows: [object,[type array]] call nearestObject
//object - an object you want to center the search on.
//type array - an array of object types, in quotes. The command finds the nearest object
//of one of these types.

private ["_center", "_objectlist", "_lowestdist", "_i", "_max", "_object", "_dist", "_closestobject"];

_center = _this select 0;
_objectlist = [];
_objectlist = _this select 1;
_lowestdist = 99999;
_i = 0;
_max = count _objectlist;
_closestObject = objNull;

While {_i<_max}
Do
 {
  _object = nearestObject [_center, _objectlist select _i];
  _dist = _center distance _object;

If (_dist <= _lowestdist) Then
  {
	_lowestdist = _dist;
	_closestobject = _object;
  };

  _i = _i + 1;
 };

_closestobject